#ifdef SCCS
static char sccsid[]="@(#)sphere.c	1.2 Stellar 89/07/27";
#endif
/*
			Copyright 1989 by
			Stellar Computer Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Stellar Computer Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
*/
#include <stdio.h>
#include "geom.h"


/*
 * This is a template converter that converts simple sphere objects into 
 * geom format.  It uses the format used by the xmole demo program.
 *  
 *	xmin ymin zmin
 *	xmax ymax zmax
 *	Number_of_molecules
 * 	<center1x> <center1y> <center1z> <radius> <col1r> <col1g> <col1b> 
 *	.
 *	.
 *	<EOF>
 */
main()
{
   int i, num;
   GEOMobj *obj;
   float ext[6];
   float *centers, *colors, *radii;

   /* Read in the extent */
   scanf("%f%f%f%f%f%f",&ext[0],&ext[2],&ext[4],&ext[1],&ext[3],&ext[5]);

   scanf("%d",&num);
   centers = (float *)malloc((unsigned)(num*sizeof(float)*3));
   colors = (float *)malloc((unsigned)(num*sizeof(float)*3));
   radii = (float *)malloc((unsigned)(num*sizeof(float)));
   for (i = 0; i < num; i++)
      scanf("%f%f%f%f%f%f%f",&centers[i*3],&centers[i*3+1],&centers[i*3+2],
	    &radii[i],&colors[i*3],&colors[i*3+1],&colors[i*3+2]);
      
   /* 
    * Since we have allocated the data with "malloc", we can use the 
    * GEOM_DONT_COPY_DATA flag.  If the data were statically allocated,
    * we could not use this flag.
    */ 
   obj=GEOMcreate_sphere(ext,centers,radii,NULL,NULL,num,GEOM_DONT_COPY_DATA);
   GEOMadd_float_colors(obj,colors,num,GEOM_DONT_COPY_DATA);
   /* Scales the extent set on the object to lie withinthe cube -1,1 in x,y,z*/
   GEOMauto_transform(obj);
   GEOMwrite_obj(obj,fileno(stdout),0);

   exit(0);
}
